<?php class cmsWysiwygQuill{ 	function __construct(){} 	
	public function displayEditor($field_id, $content=''){
		$config = cmsConfig::getInstance(); 	  
?>

<link href="/wysiwyg/quill/quill.snow.css" rel="stylesheet">
<script src="/wysiwyg/quill/quill.js"></script>
<script src="/wysiwyg/quill/image-upload.min.js"></script>

<div id="<?php echo $field_id; ?>"><?php echo $content; ?></div>

<script>
var toolbarOptions = [
  ['bold', 'italic', 'underline', 'strike'], 
  ['blockquote', 'code-block'],
  [{ 'list': 'ordered'}, { 'list': 'bullet' }],
  [{ 'indent': '-1'}, { 'indent': '+1' }],     
  [{ 'direction': 'rtl' }],  ['link', 'image', 'video'] ,                 
  [{ 'header': [1, 2, 3, 4, 5, 6, false] }],
  [{ 'color': [] }, { 'background': [] }],     
  [{ 'font': [] }],
  [{ 'align': [] }],
  ['clean']                                     
];
var quill_<?php echo $field_id; ?> = new Quill('#<?php echo $field_id; ?>', {
  modules: {
    toolbar: toolbarOptions,
	imageUpload: {
        url: "/photos/quill_upload",
        method: "POST",
        headers: {},
        callbackOK: (serverResponse, next) => {
			if(serverResponse.success == 1){
			const range = quill_<?php echo $field_id; ?>.getSelection();
      		quill_<?php echo $field_id; ?>.insertEmbed(range.index, 'image', '<?php echo $config->upload_root; ?>' + serverResponse.url);
			}
            next(serverResponse);   
        },
        callbackKO: (serverError) => {
            alert(serverError);
        }
    }
  },
  placeholder: '',
  theme: 'snow'
});
$('#f_<?php echo $field_id; ?>').append(
	'<textarea style="display:none;" name="<?php echo $field_id; ?>" id="hquill_<?php echo $field_id; ?>"></textarea>'
);

$('#f_<?php echo $field_id; ?> textarea[name="<?php echo $field_id; ?>"]').text(quill_<?php echo $field_id; ?>.root.innerHTML);

quill_<?php echo $field_id; ?>.on('text-change', function() {
  $('#f_<?php echo $field_id; ?> textarea[name="<?php echo $field_id; ?>"]').text(quill_<?php echo $field_id; ?>.root.innerHTML);
});

    function selectLocalImage() {
      const input = document.createElement('input');
      input.setAttribute('type', 'file');
      input.click();

      /* Listen upload local image and save to server */
      input.onchange = () => {
        const file = input.files[0];

        /* file type is only image. */
        if (/^image\//.test(file.type)) {
          saveToServer(file);
        } else {
          console.warn('You could only upload images.');
        }
      };
    }
</script>
<?php 	} } ?>